var CREDIT_CARD = /^(?:4[0-9]{12}(?:[0-9]{3})?|5[1-5][0-9]{14}|6(?:011|5[0-9][0-9])[0-9]{12}|3[47][0-9]{13}|3(?:0[0-5]|[68][0-9])[0-9]{11}|(?:2131|1800|35\d{3})\d{11})$/

module.exports = function (value) {
  //remove all dashes, spaces, etc.
  var sanitized = value.replace(/[^0-9]+/g, '')

  if (!CREDIT_CARD.test(sanitized))
    return false

  // Doing Luhn check
  var sum = 0
    , digit
    , tmpNum
    , shouldDouble = false

  for (var i = sanitized.length - 1; i >= 0; i--) {
    digit = sanitized.substring(i, (i + 1))
    tmpNum = parseInt(digit, 10)

    if (shouldDouble) {
      tmpNum *= 2
      sum += (tmpNum >= 10 ? ((tmpNum % 10) + 1) : tmpNum)
    }
    else
      sum += tmpNum

    shouldDouble = (shouldDouble ? false : true)
  }

  return ((sum % 10) === 0 ? true : false)
}