// mostly copied from:
// https://github.com/chriso/node-validator/blob/master/lib/validators.js

var ALPHA = /^[a-zA-Z]+$/
exports.alpha = function (value) {
  return ALPHA.test(value)
}

var ALPHANUMERIC = /^[a-zA-Z\d]+$/
exports.alphanumeric = function (value) {
  return ALPHANUMERIC.test(value)
}

var NOTEMPTY = /^[\s\t\r\n]*$/
exports.notempty = function (value) {
  return !NOTEMPTY.test(value)
}

var NUMERIC = /^-?[0-9]+$/
exports.numeric = function (value) {
  return NUMERIC.test(value)
}

var INTEGER = /^(?:-?(?:0|[1-9][0-9]*))$/
exports.integer = function (value) {
  return INTEGER.test(value)
}

var DECIMAL = /^(?:-?(?:[0-9]+))?(?:\.[0-9]*)?(?:[eE][\+\-]?(?:[0-9]+))?$/
exports.decimal = function (value) {
  return DECIMAL.test(value)
}

var HEXADECIMAL = /^(0x)?[0-9a-f]+$/i
exports.hexadecimal = function (value) {
  return HEXADECIMAL.test(value)
}

var COLORHEX = /^#?([0-9a-fA-F]{3}|[0-9a-fA-F]{6})$/
exports.colorhex = function (value) {
  return COLORHEX.test(value)
}