var types = require('./types')

;['creditcard', 'email', 'isbn',  'network', 'url', 'length'].forEach(function (file) {
  var type = require('./'+ file)

  if ('function' === typeof type)
    types[file] = type
  else
    Object.keys(type).forEach(function (method) {
      types[method] = type[method]
    })
})


function validate (str) {
  function fn (value) {
    return fn.test(value)
  }

  fn.test = function (value) {
    var bool = true

    if (undefined === value || null === value)
      return false

    if ('string' !== typeof value)
      value = value.toString()

    str.split(' ').some(function (type, params) {
      type = type.toLowerCase()

      // check for params
      if (~type.indexOf(':')) {
        params = type.split(':')
        type = params[0]
        params = params[1]
      }

      if (!types[type])
        throw new Error('validate(): the "'+ type +'" test is not implemented')

      bool = types[type](value, params)

      return !bool
    })

    return bool
  }

  return fn
}
module.exports = validate